;  nasm -f elf busasmV2.asm   for busasm.o

section .text

    global _cpuida   

 _cpuida:

    push eax
    push ebx
    push ecx
    push edx
    push edi

    mov  eax, 1
    CPUID
    mov [eaxCode1], eax  ; Features Code
    mov [edxCode1], edx  ; family/model/stepping
    mov [ebxCode1], ebx
    mov [ecxCode1], ecx

    mov  edi, idString1
    mov  eax, 0
    CPUID
    mov[edi],   ebx
    mov[edi+4], edx
    mov[edi+8], ecx
    mov ecx, 0
    mov[edi+12], ecx
    mov [intel1amd2], ebx


    ; get specials
    mov eax,80000000h
    CPUID
    cmp eax,80000000h
    jc nomore

    mov eax, [intel1amd2]
    cmp eax, 756E6547h    ; uneG
    jz intel
    cmp eax, 68747541h    ; htuA
    jnz nomore
    mov eax,80000001h
    CPUID

    mov [ext81edx], edx

    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  edi, idString2
    mov eax,80000002h
    CPUID
    mov[edi],    eax
    mov[edi+4],  ebx
    mov[edi+8],  ecx
    mov[edi+12], edx
    mov eax,80000003h
    CPUID
    mov[edi+16], eax
    mov[edi+20], ebx
    mov[edi+24], ecx
    mov[edi+28], edx
    mov eax,80000004h
    CPUID
    mov[edi+32], eax
    mov[edi+36], ebx
    mov[edi+40], ecx
    mov[edi+44], edx
    mov ecx, 0
    mov[edi+48], ecx
    jmp nomore
   intel:
    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  edi, idString2
    mov eax,80000002h
    CPUID
    mov[edi],    eax
    mov[edi+4],  ebx
    mov[edi+8],  ecx
    mov[edi+12], edx
    mov eax,80000003h
    CPUID
    mov[edi+16], eax
    mov[edi+20], ebx
    mov[edi+24], ecx
    mov[edi+28], edx
    mov eax,80000004h
    CPUID
    mov[edi+32], eax
    mov[edi+36], ebx
    mov[edi+40], ecx
    mov[edi+44], edx
    mov ecx, 0
    mov[edi+48], ecx
   nomore:

    pop edi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret

section .data

 extern  idString1
 extern  idString2
 extern  eaxCode1
 extern  ebxCode1
 extern  ecxCode1
 extern  edxCode1
 extern  intel1amd2
 extern  ext81edx


section .text

    global _calculateMHz   

 _calculateMHz:

        push eax
        push edx
        push ebx 
        RDTSC 
        mov [startCount], eax 
        mov ebx, 25000
  outerloop:
        mov edx, 25000
  innerloop:    
        dec     edx
        jne     innerloop
        dec     ebx
        jne     outerloop
        RDTSC
        mov     [endCount], eax
        sub     eax, [startCount]
        mov     [cycleCount], eax        
        pop ebx
        pop edx
        pop eax
        ret

section .data

 extern  startCount
 extern  endCount
 extern  cycleCount

section .text

    global _asmsse2
      
_asmsse2:         ; pop parameters
    push    ebp
    mov     ebp, esp
    mov     eax, [ebp+8]
    pop     ebp
    push    ebx
    push    ecx
    push    edx
    push    edi
    mov     ebx, [threads]
    mov     ecx, [andarray]
    movdqa  xmm0,[ecx]
;    mov     eax, 1536
    mov     edi, [array]
    add     eax, edi
lp2:
    mov     edx, [sse2loopinc]  ; passes of 1024 bytes
lp1:pand    xmm0,[eax]     
    pand    xmm0,[eax+16]   
    pand    xmm0,[eax+32]   
    pand    xmm0,[eax+48]   
    pand    xmm0,[eax+64]   
    pand    xmm0,[eax+80]   
    pand    xmm0,[eax+96]   
    pand    xmm0,[eax+112]  
    pand    xmm0,[eax+128]      
    pand    xmm0,[eax+144]   
    pand    xmm0,[eax+160]   
    pand    xmm0,[eax+176]   
    pand    xmm0,[eax+192]   
    pand    xmm0,[eax+208]   
    pand    xmm0,[eax+224]   
    pand    xmm0,[eax+240]  
    pand    xmm0,[eax+256];
    pand    xmm0,[eax+272];
    pand    xmm0,[eax+288];
    pand    xmm0,[eax+304];
    pand    xmm0,[eax+320];
    pand    xmm0,[eax+336];
    pand    xmm0,[eax+352];
    pand    xmm0,[eax+368];
    pand    xmm0,[eax+384];
    pand    xmm0,[eax+400];
    pand    xmm0,[eax+416];
    pand    xmm0,[eax+432];
    pand    xmm0,[eax+448];
    pand    xmm0,[eax+464];
    pand    xmm0,[eax+480];
    pand    xmm0,[eax+496];
    pand    xmm0,[eax+512];
    pand    xmm0,[eax+528];
    pand    xmm0,[eax+544];
    pand    xmm0,[eax+560];
    pand    xmm0,[eax+576];
    pand    xmm0,[eax+592];
    pand    xmm0,[eax+608];
    pand    xmm0,[eax+624];
    pand    xmm0,[eax+640];
    pand    xmm0,[eax+656];
    pand    xmm0,[eax+672];
    pand    xmm0,[eax+688];
    pand    xmm0,[eax+704];
    pand    xmm0,[eax+720];
    pand    xmm0,[eax+736];
    pand    xmm0,[eax+752];
    pand    xmm0,[eax+768];
    pand    xmm0,[eax+784];
    pand    xmm0,[eax+800];
    pand    xmm0,[eax+816];
    pand    xmm0,[eax+832];
    pand    xmm0,[eax+848];
    pand    xmm0,[eax+864];
    pand    xmm0,[eax+880];
    pand    xmm0,[eax+896];
    pand    xmm0,[eax+912];
    pand    xmm0,[eax+928];
    pand    xmm0,[eax+944];
    pand    xmm0,[eax+960];
    pand    xmm0,[eax+976];
    pand    xmm0,[eax+992];
    pand    xmm0,[eax+1008];
    add     eax,1024      
    dec     edx          
    jnz     lp1           
    mov     edi, eax
    sub     edi, [array]
    add     edi, [sse2loopbytes]
    cmp     edi, [bytesToTest]
    jle     lp3 
    mov     eax, [array]
lp3:
    dec     ebx
    jnz     lp2   
    movdqa  OWORD [ecx],xmm0
    mov     edi, [array]
    sub     eax, edi 
    pop     edi
    pop     edx
    pop     ecx
    pop     ebx
    ret

section .data

 extern threads
 extern array
 extern sse2loopinc
 extern sse2loopbytes
 extern andarray
 extern bytesToTest

 

