;  nasm -f elf64 -g -F stabs busasm64.asm   for busasm64.o

section .text

    global _cpuida   

 _cpuida:

    push rax
    push rbx
    push rcx
    push rdx
    push rdi

    mov  eax, 1
    CPUID
    mov [eaxCode1], eax  ; Features Code
    mov [edxCode1], edx  ; family/model/stepping
    mov [ebxCode1], ebx
    mov [ecxCode1], ecx

    mov  rdi, idString1
    mov  eax, 0
    CPUID
    mov[rdi],   ebx
    mov[rdi+4], edx
    mov[rdi+8], ecx
    mov ecx, 0
    mov[rdi+12], ecx
    mov [intel1amd2], ebx


    ; get specials
    mov eax,80000000h
    CPUID
    cmp eax,80000000h
    jc nomore

    mov eax, [intel1amd2]
    cmp eax, 756E6547h    ; uneG
    jz intel
    cmp eax, 68747541h    ; htuA
    jnz nomore
    mov eax,80000001h
    CPUID

    mov [ext81edx], edx

    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  rdi, idString2
    mov eax,80000002h
    CPUID
    mov[rdi],    eax
    mov[rdi+4],  ebx
    mov[rdi+8],  ecx
    mov[rdi+12], edx
    mov eax,80000003h
    CPUID
    mov[rdi+16], eax
    mov[rdi+20], ebx
    mov[rdi+24], ecx
    mov[rdi+28], edx
    mov eax,80000004h
    CPUID
    mov[rdi+32], eax
    mov[rdi+36], ebx
    mov[rdi+40], ecx
    mov[rdi+44], edx
    mov ecx, 0
    mov[rdi+48], ecx
    jmp nomore
   intel:
    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  rdi, idString2
    mov eax,80000002h
    CPUID
    mov[rdi],    eax
    mov[rdi+4],  ebx
    mov[rdi+8],  ecx
    mov[rdi+12], edx
    mov eax,80000003h
    CPUID
    mov[rdi+16], eax
    mov[rdi+20], ebx
    mov[rdi+24], ecx
    mov[rdi+28], edx
    mov eax,80000004h
    CPUID
    mov[rdi+32], eax
    mov[rdi+36], ebx
    mov[rdi+40], ecx
    mov[rdi+44], edx
    mov ecx, 0
    mov[rdi+48], ecx
   nomore:

    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret

section .data

 extern  idString1
 extern  idString2
 extern  eaxCode1
 extern  ebxCode1
 extern  ecxCode1
 extern  edxCode1
 extern  intel1amd2
 extern  ext81edx


section .text

    global _calculateMHz   

 _calculateMHz:

        push rax
        push rdx
        push rbx 
        RDTSC 
        mov [startCount], eax 
        mov ebx, 25000
  outerloop:
        mov edx, 25000
  innerloop:    
        dec     edx
        jne     innerloop
        dec     ebx
        jne     outerloop
        RDTSC
        mov     [endCount], eax
        sub     eax, [startCount]
        mov     [cycleCount], eax        
        pop rbx
        pop rdx
        pop rax
        ret

section .data

 extern  startCount
 extern  endCount
 extern  cycleCount


   global  _asmsse2

   section .text
      
 _asmsse2:                               ; parameter to rdi
    push    rbx
    mov     ebx, [threads]
    mov     ecx, [andarray]
    movdqa  xmm0,[ecx]
    mov     rax, [array]
    add     rax, rdi
lp2:
    mov     edx, [sse2loopinc]  ; passes of 1024 bytes
lp1:pand    xmm0,[rax]     
    pand    xmm0,[rax+16]   
    pand    xmm0,[rax+32]   
    pand    xmm0,[rax+48]   
    pand    xmm0,[rax+64]   
    pand    xmm0,[rax+80]   
    pand    xmm0,[rax+96]   
    pand    xmm0,[rax+112]  
    pand    xmm0,[rax+128]      
    pand    xmm0,[rax+144]   
    pand    xmm0,[rax+160]   
    pand    xmm0,[rax+176]   
    pand    xmm0,[rax+192]   
    pand    xmm0,[rax+208]   
    pand    xmm0,[rax+224]   
    pand    xmm0,[rax+240]  
    pand    xmm0,[rax+256]
    pand    xmm0,[rax+272]
    pand    xmm0,[rax+288]
    pand    xmm0,[rax+304]
    pand    xmm0,[rax+320]
    pand    xmm0,[rax+336]
    pand    xmm0,[rax+352]
    pand    xmm0,[rax+368]
    pand    xmm0,[rax+384]
    pand    xmm0,[rax+400]
    pand    xmm0,[rax+416]
    pand    xmm0,[rax+432]
    pand    xmm0,[rax+448]
    pand    xmm0,[rax+464]
    pand    xmm0,[rax+480]
    pand    xmm0,[rax+496]
    pand    xmm0,[rax+512]
    pand    xmm0,[rax+528]
    pand    xmm0,[rax+544]
    pand    xmm0,[rax+560]
    pand    xmm0,[rax+576]
    pand    xmm0,[rax+592]
    pand    xmm0,[rax+608]
    pand    xmm0,[rax+624]
    pand    xmm0,[rax+640]
    pand    xmm0,[rax+656]
    pand    xmm0,[rax+672]
    pand    xmm0,[rax+688]
    pand    xmm0,[rax+704]
    pand    xmm0,[rax+720]
    pand    xmm0,[rax+736]
    pand    xmm0,[rax+752]
    pand    xmm0,[rax+768]
    pand    xmm0,[rax+784]
    pand    xmm0,[rax+800]
    pand    xmm0,[rax+816]
    pand    xmm0,[rax+832]
    pand    xmm0,[rax+848]
    pand    xmm0,[rax+864]
    pand    xmm0,[rax+880]
    pand    xmm0,[rax+896]
    pand    xmm0,[rax+912]
    pand    xmm0,[rax+928]
    pand    xmm0,[rax+944]
    pand    xmm0,[rax+960]
    pand    xmm0,[rax+976]
    pand    xmm0,[rax+992]
    pand    xmm0,[rax+1008]
    add     rax,1024      
    dec     edx          
    jnz     lp1           
    mov     rdi, rax
    sub     rdi, [array]
    add     rdi, [sse2loopbytes]
    cmp     rdi, [bytesToTest]
    jle    lp3 
    mov     rax, [array]
lp3:
    dec     ebx
    jnz     lp2   
    movdqa  OWORD [ecx],xmm0
    mov     rdi, [array]
    sub     rax, rdi
    pop     rbx
    ret

section .data

 extern threads
 extern array
 extern sse2loopinc
 extern sse2loopbytes
 extern andarray
 extern bytesToTest
 extern wordBytes

