/*
gcc MPmemspeed.c cpuidc64.o cpuida64.o -m64 -lrt -lc -lm -O3 -o MPmemspeed64
./MPmemspeed64

gcc MPmemspeed.c cpuidc.o cpuida.o  -lrt -lc -lm -O3  -o MPmemspeed32
./MPmemspeed32

Affinity Setting
taskset 0x00000001 ./MPmemspeed64

*/

 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include "cpuidh.h"
 #include <math.h>
 #include <malloc.h>
 #include <mm_malloc.h>

  #define Integer64Bits
//  #define Integer32Bits

  #define version  "64 Bit Version 1"
//  #define version  "32 Bit Version 1"


  #ifdef Integer64Bits
   typedef struct 
   { 
      double     * axd;
      double     * ayd;
      float      * axs;
      float      * ays;      
      long long  * axi;   
      long long  * ayi;
   }
   XYDATA;
  #else
   typedef struct 
   { 
      double     * axd;
      double     * ayd;
      float      * axs;
      float      * ays;      
      int        * axi; 
      int        * ayi;
   }
   XYDATA;
  #endif

  XYDATA xydata;

  pthread_t tid[100]; 
  pthread_attr_t * attrt = NULL; 

  int  threads = 1;
  int  vlen;

  double runSecs = 0.1;   
  int n1;
  int test;


  int kd, ks, ki;
  double sumd;
  float  sums;
  #ifdef Integer64Bits
   long long  sumi;   
  #else
   int  sumi;
  #endif


  void *runTests(void *arg)
  {
     int i;
     long m;
     long thread;
     long start;
     long length;
     long end;

     double * xd;
     double * yd;
     float  * xs;
     float  * ys;
    #ifdef Integer64Bits
     long long  * xi;   
     long long  * yi;   
    #else
     int    * xi; 
     int    * yi;
    #endif

     thread = (long)arg;
   
     xd = xydata.axd;
     yd = xydata.ayd;
     xs = xydata.axs;
     ys = xydata.ays;
     xi = xydata.axi;
     yi = xydata.ayi;


     if (test == 1)
     {
        length = (long)(kd/threads);
        start  = thread * length;
        end    = start + length;
        for (i=0; i<n1; i++)
        {
           for (m=start; m<end; m=m+4)
           {
              xd[m]   = xd[m]   + sumd * yd[m];
              xd[m+1] = xd[m+1] + sumd * yd[m+1];
              xd[m+2] = xd[m+2] + sumd * yd[m+2];
              xd[m+3] = xd[m+3] + sumd * yd[m+3];
           }
        }
     }

     if (test == 2)
     {
        length = (long)(ks/threads);
        start  = thread * length;
        end    = start + length;
        for (i=0; i<n1; i++)
        {
           for (m=start; m<end; m=m+4)
           {
              xs[m]   = xs[m]   + sums * ys[m];
              xs[m+1] = xs[m+1] + sums * ys[m+1];
              xs[m+2] = xs[m+2] + sums * ys[m+2];
              xs[m+3] = xs[m+3] + sums * ys[m+3];
           }
        }
     }
 
     if (test == 3)
     {
        length = (long)(ki/threads);
        start  = thread * length;
        end    = start + length;
        for (i=0; i<n1; i++)
        {
           for (m=start; m<end; m=m+4)
           {
              xi[m]   = xi[m]   + sumi + yi[m];
              xi[m+1] = xi[m+1] + sumi + yi[m+1];
              xi[m+2] = xi[m+2] + sumi + yi[m+2];
              xi[m+3] = xi[m+3] + sumi + yi[m+3];
           }
        }
     }
     if (test == 4)
     {
        length = (long)(kd/threads);
        start  = thread * length;
        end    = start + length;
        for (i=0; i<n1; i++)
        {
           for (m=start; m<end; m=m+4)
           {
              xd[m]   = xd[m] + yd[m];
              xd[m+1] = xd[m+1] + yd[m+1];
              xd[m+2] = xd[m+2] + yd[m+2];
              xd[m+3] = xd[m+3] + yd[m+3];
           }
        }
     }
     if (test == 5)
     {
        length = (long)(ks/threads);
        start  = thread * length;
        end    = start + length;
        for (i=0; i<n1; i++)
        {
           for (m=start; m<end; m=m+4)
           {
              xs[m] = xs[m] + ys[m];
              xs[m+1] = xs[m+1] + ys[m+1];
              xs[m+2] = xs[m+2] + ys[m+2];
              xs[m+3] = xs[m+3] + ys[m+3];
           }
        }
     }
     if (test == 6)
     {
        length = (long)(ki/threads);
        start  = thread * length;
        end    = start + length;
        for (i=0; i<n1; i++)
        {
           for (m=start; m<end; m=m+4)
           {
              xi[m] = xi[m] + yi[m];
              xi[m+1] = xi[m+1] + yi[m+1];
              xi[m+2] = xi[m+2] + yi[m+2]; 
              xi[m+3] = xi[m+3] + yi[m+3]; 
           }
        }
     }
     if (test == 7)
     {
        length = (long)(kd/threads);
        start  = thread * length;
        end    = start + length;
        for (i=0; i<n1; i++)
        {
           for (m=start; m<end; m=m+4)
           {
              xd[m] = yd[m];
              xd[m+1]=yd[m+1];
              xd[m+2]=yd[m+2];
              xd[m+3]=yd[m+3];
           }
        }
     }
     if (test == 8)
     {
        length = (long)(ks/threads);
        start  = thread * length;
        end    = start + length;
        for (i=0; i<n1; i++)
        {
           for (m=start; m<end; m=m+4)
           {
              xs[m] = ys[m];
              xs[m+1]=ys[m+1];
              xs[m+2]=ys[m+2];
              xs[m+3]=ys[m+3];
           }
        }
     }
     if (test == 9)
     {
        length = (long)(ki/threads);
        start  = thread * length;
        end    = start + length;
        for (i=0; i<n1; i++)
        {
           for (m=start; m<end; m=m+4)
           {
              xi[m] = yi[m];
              xi[m+1]=yi[m+1];
              xi[m+2]=yi[m+2];
              xi[m+3]=yi[m+3];
           }
        }
     }
  }

  void checkTime()
  {
     if (secs < runSecs)
     {
          if (secs < runSecs / 8.0)
          {
                n1 = n1 * 10;
          }
          else
          {
                n1 = (int)(runSecs * 1.25 / secs * (double)n1+1);
          }
      }
  }


int main(int argc, char *argv[])
{
    double * xd;
    double * yd;
    float  * xs;
    float  * ys;
    #ifdef Integer64Bits
     long long  * xi;   
     long long  * yi;
     long long  errori[4][2];   
    #else
     int    * xi; 
     int    * yi;
     int    errori[4][2];
    #endif

    int passes[25];
    int allocMem[25];
    int errorCount[10];

    double errord[4][2];
    float  errors[4][2];
    
    double  ramKB;
    int useMem;   

    float  ones = 1.0;
    float  zeros = 0;
      
    int g, i, m, j, nn;
    int mem;

    long  t;
   
    int  zeroi = 0;
    int onei = 1;
             
    double mbpsd, mbpss, mbpsi;
    double oned = 1.0;
    double zerod = 0;
    double memMB;
    
    int runs = 10; // 2 MB;
    FILE    *outfile;
    int     param01 = 0;

    for (i=1; i<3; i=i+2)
    {
       if (argc > i)
       {
          switch (toupper(argv[i][0]))
          {
                case 'T':
                if (argc > i+1)
                {
                   sscanf(argv[i+1],"%d", &param01);
                   if (param01 > 0) threads = param01;
                }
                break;
         }
       }
    }
    
    outfile = fopen("memSpeedMP.txt","a+");
    if (outfile == NULL)
    {
        printf ("Cannot open results file \n\n");
        printf(" Press Enter\n");
        g  = getchar();
        exit (0);
    }
    printf("\n");
    getDetails();
    if (param01 == 0)
    {
        threads = CPUavail;
    }
    if (threads > 32)
    {
        threads = 64;
    }
    else if (threads > 16)
    {
        threads = 32;
    }
    else if (threads >  8)
    {
        threads = 16;
    }
    else if (threads >  4)
    {
        threads =  8;
    }
    else if (threads >  2)
    {
        threads =  4;
    }
 
    for (i=1; i<10; i++)
    {
        printf("%s\n", configdata[i]);
    }
    printf("\n");

    fprintf (outfile, " #####################################################\n\n");                     
    for (i=1; i<10; i++)
    {
        fprintf(outfile, "%s \n", configdata[i]);
    }
    fprintf (outfile, "\n");
 
    printf(" ##########################################\n"); 
    fprintf (outfile, " #####################################################\n\n");                     


    ramKB = ramGB * 1000000;

    allocMem[0] =    2; 
    passes[0]   =  256; 
    for (i=1; i<23; i++)
    {
        allocMem[i] = allocMem[i-1] * 2;  //   2 to    8388608 KB        x 2 arrays  
        passes[i]   = passes[i-1]   * 2;  // 256 to 1073741824 DP Words  x 2 arrays
    }


    if (ramKB >    14000) runs = 11;  // use  4 MB out of  16 MB
    if (ramKB >    30000) runs = 12;
    if (ramKB >    60000) runs = 13;
    if (ramKB >   120000) runs = 14;  // use 32 MB out of 128 MB
    if (ramKB >   250000) runs = 15;
    if (ramKB >   500000) runs = 16;
    if (ramKB >  1000000) runs = 17;
    if (ramKB >  1500000) runs = 18;
    if (ramKB >  3500000) runs = 19;
    if (ramKB >  7500000) runs = 20;
    if (ramKB > 15500000) runs = 21;
    if (ramKB > 31500000) runs = 22;
    if (ramKB > 63500000) runs = 23;  // use 16 GB out of  64 GB

    useMem = allocMem[runs - 1] + 1;

    xd = (double *)_mm_malloc(useMem * 1024, 16);
    if (xd == NULL)
    {
       printf(" ERROR WILL EXIT\n");
       printf(" Press Enter\n");
       g  = getchar();
       exit(1);
    }

    yd = (double *)_mm_malloc(useMem * 1024, 16);
    if (yd == NULL)
    {
       printf(" ERROR WILL EXIT\n");
       printf(" Press Enter\n");
        _mm_free(xd);
       g  = getchar();
       exit(1);
    }

    xs = (float *) xd;
    ys = (float *) yd;

    #ifdef Integer64Bits
     xi = (long long *) xd;
     yi = (long long *) yd;     
    #else
     xi = (int *) xd;
     yi = (int *) yd;     
    #endif


    xydata.axd = xd;
    xydata.ayd = yd;
    xydata.axs = xs;
    xydata.ays = ys;
    xydata.axi = xi;
    xydata.ayi = yi;


    local_time();
    
    printf("     MP Memory Reading Speed Test %s Using %d Threads\n", version, threads);
    printf("\n               Start of test %s\n", timeday);
    printf("  Memory   x[m]=x[m]+s*y[m] Int  x[m]=x[m]+y[m]         x[m]=y[m]\n"); 

    fprintf(outfile, "     MP Memory Reading Speed Test %s Using %d Threads\n", version, threads);
    fprintf(outfile, "\n               Start of test %s\n", timeday);
    fprintf(outfile, "  Memory   x[m]=x[m]+s*y[m] Int+   x[m]=x[m]+y[m]         x[m]=y[m]\n"); 

    #ifdef Integer64Bits
     printf("  KBytes    Dble   Sngl  Int64   Dble   Sngl  Int64   Dble   Sngl  Int64\n");   
     fprintf(outfile, "  KBytes    Dble   Sngl  Int64   Dble   Sngl  Int64   Dble   Sngl  Int64\n");     
    #else
     printf("  KBytes    Dble   Sngl  Int32   Dble   Sngl  Int32   Dble   Sngl  Int32\n");   
     fprintf(outfile, "  KBytes    Dble   Sngl  Int32   Dble   Sngl  Int32   Dble   Sngl  Int32\n");     
    #endif

    printf("    Used    MB/S   MB/S   MB/S   MB/S   MB/S   MB/S   MB/S   MB/S   MB/S\n\n");
    fprintf(outfile, "    Used    MB/S   MB/S   MB/S   MB/S   MB/S   MB/S   MB/S   MB/S   MB/S\n\n");
       
    for (j=1; j<10; j++)
    {
        errorCount[j] = 0;
    }
    for (j=0; j<runs; j++)
    {
        kd = passes[j];
        nn = 6400000 / kd;
        if (nn < 1) nn = 1;
        
        ks = kd * 2;

        #ifdef Integer64Bits   
         ki = kd; 
        #else
         ki = kd * 2; 
        #endif
        
        memMB = (double)kd * 16.0 / 1000000;
        mem = (int)((double)kd * 16.0 / 1000);
          
        n1 = nn;
        test = 1;
        
        do
        {
            sumd = 1.00001;
            for (m=0; m<kd; m++)
            {
                  xd[m] = oned;
                  yd[m] = oned;
            }          
            start_time();            
            for (t=0; t<threads; t++)
            {
                 pthread_create(&tid[t], attrt, runTests, (void *)t);
            }
            for (t=0; t<threads; t++)
            {
                 pthread_join(tid[t], NULL);                
            }
            end_time();
            checkTime();
        }
        while (secs < runSecs);
        
        mbpsd = (double)n1 * memMB / secs;
        printf("%8d %7d", mem, (int)mbpsd);
        fprintf(outfile, "%8d %7d", mem, (int)mbpsd);
        for (m=1; m<kd; m++)
        {
            if (xd[m] != xd[0])
            {
                errorCount[1] = errorCount[1] + 1;
                if (errorCount[1] == 1)
                {
                    errord[1][0] = xd[0];
                    errord[1][1] = xd[m];
                    printf (" ERROR");
                }
            }
        }
        fflush(stdout);
                
        n1 = nn;
        test = 2;
        do
        {
            sums = 1.0001;
            for (m=0; m<ks; m++)
            {
                  xs[m] = ones;
                  ys[m] = ones;
            }          
            start_time();
            for (t=0; t<threads; t++)
            {
                 pthread_create(&tid[t], attrt, runTests, (void *)t);
            }
            for (t=0; t<threads; t++)
            {
                 pthread_join(tid[t], NULL);                
            }
            end_time();
            checkTime();
        }
        while (secs < runSecs);

        mbpss =  (double)n1 * memMB / secs;
        printf("%7d", (int)mbpss);
        fprintf(outfile, "%7d", (int)mbpss);
        for (m=1; m<ks; m++)
        {
            if (xs[m] != xs[0])
            {
                errorCount[2] = errorCount[2] + 1;
                if (errorCount[2] == 1)
                {
                    errors[1][0] = xs[0];
                    errors[1][1] = xs[m];
                    printf (" ERROR");
                }
            }
        }
        fflush(stdout);
         
        n1 = nn;
        test = 3;
        do
        {
            sumi = nn;
            for (m=0; m<ki; m++)
            {
                  xi[m] = zeroi;
                  yi[m] = zeroi;
            }          
                     
            start_time();
            for (t=0; t<threads; t++)
            {
                 pthread_create(&tid[t], attrt, runTests, (void *)t);
            }
            for (t=0; t<threads; t++)
            {
                 pthread_join(tid[t], NULL);                
            }
            end_time();
            checkTime();
        }
        while (secs < runSecs);
                  
        mbpsi = (double)n1 * memMB / secs;
        printf("%7d", (int)mbpsi);
        fprintf(outfile, "%7d", (int)mbpsi);
        for (m=1; m<ki; m++)
        {
            if (xi[m] != xi[0])
            {
                errorCount[3] = errorCount[3] + 1;
                if (errorCount[3] == 1)
                {
                    errori[1][0] = xi[0];
                    errori[1][1] = xi[m];
                    printf (" ERROR");
                }
            }
        }
        fflush(stdout);
            
        n1 = nn;
        test = 4;
        do
        {
            for (m=0; m<kd; m++)
            {
                  xd[m] = zerod;
                  yd[m] = oned;
            }          
            start_time();
            for (t=0; t<threads; t++)
            {
                 pthread_create(&tid[t], attrt, runTests, (void *)t);
            }
            for (t=0; t<threads; t++)
            {
                 pthread_join(tid[t], NULL);                
            }
            end_time();
            checkTime();
        }
        while (secs < runSecs);
    
        sumd = xd[1];

        mbpsd = (double)n1 * memMB / secs;
        printf("%7d", (int)mbpsd);
        fprintf(outfile, "%7d", (int)mbpsd);
        for (m=1; m<kd; m++)
        {
            if (xd[m] != xd[0])
            {
                errorCount[4] = errorCount[4] + 1;
                if (errorCount[4] == 1)
                {
                    errord[2][0] = xd[0];
                    errord[2][1] = xd[m];
                    printf (" ERROR");
                }
            }
        }
        fflush(stdout);

        n1 = nn;
        test = 5;
        do
        {
            for (m=0; m<ks; m++)
            {
                  xs[m] = zeros;
                  ys[m] = ones;
            }          
            start_time();
            for (t=0; t<threads; t++)
            {
                 pthread_create(&tid[t], attrt, runTests, (void *)t);
            }
            for (t=0; t<threads; t++)
            {
                 pthread_join(tid[t], NULL);                
            }
            end_time();
            checkTime();
        }
        while (secs < runSecs);
            
        sums = xs[1];
        mbpss = (double)n1 * memMB / secs;
        printf("%7d", (int)mbpss);
        fprintf(outfile, "%7d", (int)mbpss);
        for (m=1; m<ks; m++)
        {
            if (xs[m] != xs[0])
            {
                errorCount[5] = errorCount[5] + 1;
                if (errorCount[5] == 1)
                {
                    errors[2][0] = xs[0];
                    errors[2][1] = xs[m];
                    printf (" ERROR");
                }
            }
        }
        fflush(stdout);

        n1 = nn;
        test = 6;
        do
        {
            for (m=0; m<ki; m++)
            {
                  xi[m] = zeroi;
                  yi[m] = onei;
            }          
                    
            start_time();
            for (t=0; t<threads; t++)
            {
                 pthread_create(&tid[t], attrt, runTests, (void *)t);
            }
            for (t=0; t<threads; t++)
            {
                 pthread_join(tid[t], NULL);                
            }
            end_time();
            checkTime();
        }
        while (secs < runSecs);
     
        sumi = xi[1];
        mbpsi = (double)n1 * memMB / secs;
        printf("%7d", (int)mbpsi);
        fprintf(outfile, "%7d", (int)mbpsi);
        for (m=1; m<ki; m++)
        {
            if (xi[m] != xi[0])
            {
                errorCount[6] = errorCount[6] + 1;
                if (errorCount[6] == 1)
                {
                    errori[2][0] = xi[0];
                    errori[2][1] = xi[m];
                    printf (" ERROR");
                }
            }
        }
        fflush(stdout);
        
        memMB = (double)kd * 8 / 1000000;
    
        n1 = nn;
        test = 7;
        do
        {              
            for (m=0; m<kd+4; m++)
            {
                  xd[m] = zerod;
                  yd[m] = m;
            }        
            start_time();
            for (t=0; t<threads; t++)
            {
                 pthread_create(&tid[t], attrt, runTests, (void *)t);
            }
            for (t=0; t<threads; t++)
            {
                 pthread_join(tid[t], NULL);                
            }
            end_time();
            checkTime();
        }
        while (secs < runSecs);
            
        sumd = xd[kd-1]+1;
        mbpsd = (double)n1 * memMB / secs;
        printf("%7d", (int)mbpsd);
        fprintf(outfile, "%7d", (int)mbpsd);
        for (m=0; m<kd; m++)
        {
            if (xd[m] != (double)m)
            {
                errorCount[7] = errorCount[7] + 1;
                if (errorCount[7] == 1)
                {
                    errord[3][0] = (double)m;
                    errord[3][1] = xd[m];
                    printf (" ERROR");
                }
            }
        }
        fflush(stdout);
        
        n1 = nn;
        test = 8;
        do
        {
            for (m=0; m<ks+4; m++)
            {
                  xs[m] = zeros;
                  ys[m] = (float)(1.0/(double)m);
            }        
            start_time();
            for (t=0; t<threads; t++)
            {
                 pthread_create(&tid[t], attrt, runTests, (void *)t);
            }
            for (t=0; t<threads; t++)
            {
                 pthread_join(tid[t], NULL);                
            }
            end_time();
            checkTime();
        }
        while (secs < runSecs);
        
        sums = xs[ks-1]+1;    
        mbpss = (double)n1 * memMB / secs;
        printf("%7d", (int)mbpss);
        fprintf(outfile, "%7d", (int)mbpss);
        for (m=0; m<ks; m++)
        {
            if (xs[m] != (float)(1.0/(double)m))
            {
                errorCount[8] = errorCount[8] + 1;
                if (errorCount[8] == 1)
                {
                    errors[3][0] = (float)(1.0/(double)m);
                    errors[3][1] = xs[m];
                    printf (" ERROR");
                }
            }
        }
        fflush(stdout);

        n1 = nn;
        test = 9;
        do
        {
            for (m=0; m<ki+4; m++)
            {
                  xi[m] = zeroi;
                  yi[m] = m;
            }
                    
            start_time();
            for (t=0; t<threads; t++)
            {
                 pthread_create(&tid[t], attrt, runTests, (void *)t);
            }
            for (t=0; t<threads; t++)
            {
                 pthread_join(tid[t], NULL);                
            }
            end_time();
            checkTime();
        }
        while (secs < runSecs);

        sumi = xi[ki-1]+1;
        mbpsi = (double)n1 * memMB / secs;
        printf("%7d\n", (int)mbpsi);
        fprintf(outfile, "%7d\n", (int)mbpsi);
        for (m=0; m<ki; m++)
        {
            if (xi[m] != m)
            {
                errorCount[9] = errorCount[9] + 1;
                if (errorCount[9] == 1)
                {
                    errori[3][0] = m;
                    errori[3][1] = xi[m];
                    printf (" ERROR");
                }
            }
        }
        fflush(stdout);

        fflush(outfile);   
    }
    printf("\n");
    fprintf(outfile, "\n");
     
    j=1;
    m=0;
    for (i=1; i<4; i++)
    {
        if (errorCount[j] > 0)
        {
            m = 1;
            printf (" DP  test %d %d errors, first was %22.15e should be %22.15e\n", i, errorCount[j], errord[i][1], errord[i][0]);
            fprintf (outfile, " DP  test %d %d errors, first was %22.15e should be %22.15e\n", i, errorCount[j], errord[i][1], errord[i][0]);
        }
        j = j + 3;
    }

    j=2;
    for (i=1; i<4; i++)
    {
        if (errorCount[j] > 0)
        {
            m = 1;
            printf (" SP  test %d %d errors, first was %22.15e should be %22.15e\n", i, errorCount[j], errors[i][1], errors[i][0]);
            fprintf (outfile, " SP  test %d %d errors, first was %22.15e should be %22.15e\n", i, errorCount[j], errors[i][1], errors[i][0]);
        }
        j = j + 3;
    }

    j=3;
    for (i=1; i<4; i++)
    {
        if (errorCount[j] > 0)
        {
            m = 1;
            #ifdef Integer64Bits
             printf (" Int test %d %d errors, first was %lld should be %lld\n", i, errorCount[j], errori[i][1], errori[i][0]);
             fprintf (outfile, " Int test %d %d errors, first was %lld should be %lld\n", i, errorCount[j], errori[i][1], errori[i][0]);
            #else
             printf (" Int test %d %d errors, first was %d should be %d\n", i, errorCount[j], errori[j][1], errori[j][0]);
             fprintf (outfile, " Int test %d %d errors, first was %d should be %d\n", i, errorCount[j], errori[j][1], errori[j][0]);
            #endif
        }
        j = j + 3;
    }

    if (m == 0)
    {
        printf ("                           No errors found\n\n");
        fprintf (outfile, "                           No errors found\n\n");
    }
    else
    {
        printf ("\n");
        fprintf (outfile, "\n");
    }


    
    local_time();
    printf("                End of test %s\n", timeday);
    fprintf(outfile, "                End of test %s", timeday);        
    fprintf(outfile,"\n\n\n");
    fclose(outfile);
    _mm_free(yd);
    _mm_free(xd);
    printf("  Press Enter\n");
    g  = getchar();
    return 1;
}




 

