section .text

    global _cpuida   

 _cpuida:

    push eax
    push ebx
    push ecx
    push edx
    push edi

    mov  eax, 1
    CPUID
    mov [eaxCode1], eax  ; Features Code
    mov [edxCode1], edx  ; family/model/stepping
    mov [ebxCode1], ebx
    mov [ecxCode1], ecx

    mov  edi, idString1
    mov  eax, 0
    CPUID
    mov[edi],   ebx
    mov[edi+4], edx
    mov[edi+8], ecx
    mov ecx, 0
    mov[edi+12], ecx
    mov [intel1amd2], ebx


    ; get specials
    mov eax,80000000h
    CPUID
    cmp eax,80000000h
    jc nomore

    mov eax, [intel1amd2]
    cmp eax, 756E6547h    ; uneG
    jz intel
    cmp eax, 68747541h    ; htuA
    jnz nomore
    mov eax,80000001h
    CPUID

    mov [ext81edx], edx

    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  edi, idString2
    mov eax,80000002h
    CPUID
    mov[edi],    eax
    mov[edi+4],  ebx
    mov[edi+8],  ecx
    mov[edi+12], edx
    mov eax,80000003h
    CPUID
    mov[edi+16], eax
    mov[edi+20], ebx
    mov[edi+24], ecx
    mov[edi+28], edx
    mov eax,80000004h
    CPUID
    mov[edi+32], eax
    mov[edi+36], ebx
    mov[edi+40], ecx
    mov[edi+44], edx
    mov ecx, 0
    mov[edi+48], ecx
    jmp nomore
   intel:
    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  edi, idString2
    mov eax,80000002h
    CPUID
    mov[edi],    eax
    mov[edi+4],  ebx
    mov[edi+8],  ecx
    mov[edi+12], edx
    mov eax,80000003h
    CPUID
    mov[edi+16], eax
    mov[edi+20], ebx
    mov[edi+24], ecx
    mov[edi+28], edx
    mov eax,80000004h
    CPUID
    mov[edi+32], eax
    mov[edi+36], ebx
    mov[edi+40], ecx
    mov[edi+44], edx
    mov ecx, 0
    mov[edi+48], ecx
   nomore:

    pop edi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret


    global _calculateMHz   

 _calculateMHz:

        push eax
        push edx
        push ebx 
        RDTSC 
        mov [startCount], eax 
        mov ebx, 25000
  outerloop:
        mov edx, 25000
  innerloop:    
        dec     edx
        jne     innerloop
        dec     ebx
        jne     outerloop
        RDTSC
        mov     [endCount], eax
        sub     eax, [startCount]
        mov     [cycleCount], eax        
        pop ebx
        pop edx
        pop eax
        ret




    global _mipsa4Reg   

_mipsa4Reg:

      push eax
      push ebx
      push ecx
      push edx
      push edi
      mov edi, 100000000
      mov eax, 0
      mov ebx, 0
      mov ecx, 0
      mov edx, 0
      align 8
  klp:add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 3
      dec edi
      jnz klp
      add eax, ebx
      add eax, ecx
      add eax, edx
      mov [intCounta], eax
      pop edi
      pop edx
      pop ecx
      pop ebx
      pop eax
      ret


    global _SSE4Reg   

_SSE4Reg:

        push ebx
        push eax
        mov  eax, [dsum]
        movapd    [eax], xmm6
        movapd    [eax+16], xmm7
        mov     ebx,  100000000
        mov     eax,  [ssum1]
        movaps  xmm0, [eax+16]
        movaps  xmm1, [eax] 
        movaps  xmm2, [eax+16]
        movaps  xmm3, [eax]
        movaps  xmm4, [eax+16]
        movaps  xmm5, [eax]
        movaps  xmm6, [eax+16]
        movaps  xmm7, [eax]
    blp:addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        dec     ebx
        jnz     blp
        addps   xmm1, xmm3
        addps   xmm1, xmm5
        addps   xmm1, xmm7
        movaps  [eax], xmm1
        mov  eax, [dsum]
        movapd  xmm6, [eax]
        movapd  xmm7, [eax+16]
        pop eax
        pop ebx
        ret



section .data

 extern  idString1
 extern  idString2
 extern  eaxCode1
 extern  ebxCode1
 extern  ecxCode1
 extern  edxCode1
 extern  intel1amd2
 extern  ext81edx

 extern  startCount
 extern  endCount
 extern  cycleCount

 extern intCounta
 extern icounta

 extern ssum1
 extern dsum


