section .text

    global _cpuida   

 _cpuida:

    push rax
    push rbx
    push rcx
    push rdx
    push rdi

    mov  eax, 1
    CPUID
    mov [eaxCode1], eax  ; Features Code
    mov [edxCode1], edx  ; family/model/stepping
    mov [ebxCode1], ebx
    mov [ecxCode1], ecx

    mov  rdi, idString1
    mov  eax, 0
    CPUID
    mov[rdi],   ebx
    mov[rdi+4], edx
    mov[rdi+8], ecx
    mov ecx, 0
    mov[rdi+12], ecx
    mov [intel1amd2], ebx


    ; get specials
    mov eax,80000000h
    CPUID
    cmp eax,80000000h
    jc nomore

    mov eax, [intel1amd2]
    cmp eax, 756E6547h    ; uneG
    jz intel
    cmp eax, 68747541h    ; htuA
    jnz nomore
    mov eax,80000001h
    CPUID

    mov [ext81edx], edx

    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  rdi, idString2
    mov eax,80000002h
    CPUID
    mov[rdi],    eax
    mov[rdi+4],  ebx
    mov[rdi+8],  ecx
    mov[rdi+12], edx
    mov eax,80000003h
    CPUID
    mov[rdi+16], eax
    mov[rdi+20], ebx
    mov[rdi+24], ecx
    mov[rdi+28], edx
    mov eax,80000004h
    CPUID
    mov[rdi+32], eax
    mov[rdi+36], ebx
    mov[rdi+40], ecx
    mov[rdi+44], edx
    mov ecx, 0
    mov[rdi+48], ecx
    jmp nomore
   intel:
    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  rdi, idString2
    mov eax,80000002h
    CPUID
    mov[rdi],    eax
    mov[rdi+4],  ebx
    mov[rdi+8],  ecx
    mov[rdi+12], edx
    mov eax,80000003h
    CPUID
    mov[rdi+16], eax
    mov[rdi+20], ebx
    mov[rdi+24], ecx
    mov[rdi+28], edx
    mov eax,80000004h
    CPUID
    mov[rdi+32], eax
    mov[rdi+36], ebx
    mov[rdi+40], ecx
    mov[rdi+44], edx
    mov ecx, 0
    mov[rdi+48], ecx
   nomore:

    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret


    global _calculateMHz   

 _calculateMHz:

        push rax
        push rdx
        push rbx 
        RDTSC 
        mov [startCount], eax 
        mov ebx, 25000
  outerloop:
        mov edx, 25000
  innerloop:    
        dec     edx
        jne     innerloop
        dec     ebx
        jne     outerloop
        RDTSC
        mov     [endCount], eax
        sub     eax, [startCount]
        mov     [cycleCount], eax        
        pop rbx
        pop rdx
        pop rax
        ret




    global _mipsa4Reg   

_mipsa4Reg:

      push rax
      push rbx
      push rcx
      push rdx
      push rdi
      mov rdi, 100000000
      mov rax, 0
      mov rbx, 0
      mov rcx, 0
      mov rdx, 0
      align 8
  klp:add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 3
      dec rdi
      jnz klp
      add rax, rbx
      add rax, rcx
      add rax, rdx
      mov [intCounta], rax
      pop rdi
      pop rdx
      pop rcx
      pop rbx
      pop rax
      ret

    global _SSE4Reg   

_SSE4Reg:

        push rbx
        push rax
        push rcx
        mov  rcx, [dsum]
        movapd    [rcx], xmm6
        movapd    [rcx+16], xmm7
        mov     rbx,  100000000
        mov     rax,  [ssum1]
        movaps  xmm0, [rax+16]
        movaps  xmm1, [rax] 
        movaps  xmm2, [rax+16]
        movaps  xmm3, [rax]
        movaps  xmm4, [rax+16]
        movaps  xmm5, [rax]
        movaps  xmm6, [rax+16]
        movaps  xmm7, [rax]
    blp:addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        dec     rbx
        jnz     blp
        addps   xmm1, xmm3
        addps   xmm1, xmm5
        addps   xmm1, xmm7
        movaps  [rax], xmm1
        movapd  xmm6, [rcx]
        movapd  xmm7, [rcx+16]
        pop rcx
        pop rax
        pop rbx
        ret



section .data

 extern  idString1
 extern  idString2
 extern  eaxCode1
 extern  ebxCode1
 extern  ecxCode1
 extern  edxCode1
 extern  intel1amd2
 extern  ext81edx

 extern  startCount
 extern  endCount
 extern  cycleCount

 extern intCounta
 extern icounta

 extern ssum1
 extern dsum


