/*
gcc mprandmem.c cpuidc64.o cpuida64.o -m64 -lrt -lc -lm -O3 -o MPrandmem64
./MPrandmem64

gcc mprandmem.c cpuidc.o cpuida.o  -lrt -lc -lm -O3  -o MPrandmem32
./MPrandmem32
 */

 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include "cpuidh.h"
 #include <math.h>
 #include <inttypes.h>
 #include <stdint.h>
 #include <malloc.h>
 #include <mm_malloc.h>
 #include <pthread.h>

 #define version  "64 Bit Version 1"
//  #define version  "32 Bit Version 1"
 

int           * xi;
int           threads = 1;
int           ipass;
int           test;
int           memSize;
int           extraLoops;
int           memoryWords;
int           result[64];


unsigned int memoryBytes[20];
unsigned int ramMB;
unsigned int ramKB;

double       runSecs = 0.5;


pthread_t tid[100]; 
pthread_attr_t * attrt = NULL;
pthread_mutex_t mutex1 = PTHREAD_MUTEX_INITIALIZER;


//  ************** PROTOPTYPES *****************

void thread1TestRW(int xiwr[], int t);    
void thread1TestRD(int xird[], int t);


void *runTests(void *arg)
{
    long thread;

    thread = (long)arg;

    if (test == 1) thread1TestRD(xi, thread);
    if (test == 2) thread1TestRW(xi, thread);
    if (test == 3) thread1TestRD(xi, thread);
    if (test == 4) thread1TestRW(xi, thread);
    if (test == 5) thread1TestRW(xi, thread);
    if (test == 6) thread1TestRW(xi, thread);
}

void checkTime()
{
    if (secs < runSecs)
    {
        if (secs < runSecs / 8.0)
        {
             extraLoops = extraLoops * 10;
        }
        else
        {
             extraLoops = (int)(runSecs * 1.25 / secs * (double)extraLoops+1);
        }
    }
}


int  main(int argc, char *argv[])
{
    int     i, g, k;
    int     param01 = 0;

    long    t;
    
    double  mbps;

    char   title[7][10];
    
    FILE    *outfile;

    sprintf(title[1], "Serial RD");
    sprintf(title[2], "Serial RW");
    sprintf(title[3], "Random RD");
    sprintf(title[4], "Random RW");
    sprintf(title[5], "Mutex SRW");
    sprintf(title[6], "Mutex RRW");

    for (i=1; i<3; i=i+2)
    {
       if (argc > i)
       {
          switch (toupper(argv[i][0]))
          {
                case 'T':
                if (argc > i+1)
                {
                   sscanf(argv[i+1],"%d", &param01);
                   if (param01 > 0) threads = param01;
                }
                break;
         }
       }
    }

    printf("\n");
   
    local_time();
    outfile = fopen("randmemMP.txt","a+");
    if (outfile == NULL)
    {
        printf ("Cannot open results file \n\n");
        printf(" Press Enter\n");
        g  = getchar();
        exit (0);
    }
    getDetails();
    if (param01 == 0)
    {
        threads = CPUavail;
    }
    if (threads > 32)
    {
        threads = 64;
    }
    else if (threads > 16)
    {
        threads = 32;
    }
    else if (threads >  8)
    {
        threads = 16;
    }
    else if (threads >  4)
    {
        threads =  8;
    }
    else if (threads >  2)
    {
        threads =  4;
    }
    printf("\n");
    for (i=1; i<10; i++)
    {
        printf("%s\n", configdata[i]);
    }
    fprintf (outfile, " #####################################################################\n\n");
    for (i=1; i<10; i++)
    {
        fprintf(outfile, "%s \n", configdata[i]);
    }
    printf("\n");
    printf(" ##########################################\n"); 
    printf("    RandMemMP Speeds %s, %d Threads,  %s \n", version, threads, timeday);
    printf("               ------------------ MBytes Per Second At --------------------\n");
    printf("               6 KB   24 KB   96 KB  384 KB  768 KB 1536 KB   12 MB   96 MB\n\n");


    fprintf (outfile, "\n #####################################################################\n\n");
    fprintf(outfile, "    RandMemMP Speeds %s, %d Threads, %s \n", version, threads, timeday);
    fprintf(outfile, "               ------------------ MBytes Per Second At --------------------\n");
    fprintf(outfile, "               6 KB   24 KB   96 KB  384 KB  768 KB 1536 KB   12 MB   96 MB\n\n");
    fflush(outfile);

    memoryBytes[0] = 1024 * 6;  // 1536 32 bit words
    memoryBytes[1] = 1024 * 24;
    memoryBytes[2] = 1024 * 96;
    memoryBytes[3] = 1024 * 384;
    memoryBytes[4] = 1024 * 768;
    memoryBytes[5] = 1024 * 1536;
    memoryBytes[6] = 1024 * 12288;
    memoryBytes[7] = 1024 * 98304; 

    ipass  = 8;
    ramKB = (unsigned int)(ramGB * 1000000);
    ramMB = ramKB / 1024;
    if (ramMB < 192 ) ipass = 7;
    if (ramMB < 32  ) ipass = 6;

    xi = (int *)_mm_malloc(memoryBytes[ipass-1] + 16384, 16);
    if (xi == NULL)
    {
       printf(" Cannot allocate memory ERROR WILL EXIT\n");
       printf(" Press Enter\n");
       g  = getchar();
       exit(1);
    }
    for (test=1; test<7; test++)
    {
        printf(" %s ", title[test]);
        fprintf(outfile, " %s ", title[test]);
        
        for (memSize=0; memSize<ipass; memSize++)
        {
            memoryWords = memoryBytes[memSize] / 4;
            extraLoops = 6400000 / memoryBytes[memSize];
            if (extraLoops < 1) extraLoops = 1;
            if (test == 1 || test == 2 || test == 5)
            {
                for (k=0; k<memoryWords+1; k++)
                {
                    xi[k] = k+1;
                }
            }
            else
            {
                 srand(123);

                for (k=0; k<memoryWords+1; k++)
                {
                   xi[k] = (int)((double)memoryWords * ((double)(rand()) / (double)2147483648.0));
                }                
            }
            for (k=0; k<threads; k++)
            {
                result[k] = 12345;
            }
            do
            {
                start_time();            
                for (t=0; t<threads; t++)
                {
                     pthread_create(&tid[t], attrt, runTests, (void *)t);
                }
                for (t=0; t<threads; t++)
                {
                     pthread_join(tid[t], NULL);                
                }
                end_time();
                checkTime();
            }
            while (secs < runSecs);                    
            mbps = (double)memoryBytes[memSize] / 1000000.0 * (double)extraLoops * (double)threads / secs;
            printf("%8.0f", mbps);
            fprintf(outfile, "%8.0f", mbps);
            fflush (outfile);
            fflush (stdout);
            for (k=0; k<threads; k++)
            {
                if (result[k] == 0) result[k] = 1;
            }

        }
        printf ("\n"); 
        fprintf (outfile, "\n"); 
    }


   printf ("\n"); 
   fprintf (outfile, "\n"); 
   local_time();
   fprintf (outfile, "                     End at %s\n", timeday);

   fprintf(outfile, "\n");
   fflush (outfile);
   fclose(outfile);

   _mm_free(xi);
   
   return 1;

} // main

void thread1TestRD(int xird[], int thread)    
{
  int  i, j, k;
  int  start, end, length;

  length = (int)(memoryWords/threads);
  start  = thread * length;
  end    = start  + length;
  for (j=0; j<extraLoops; j++)
  {
      for (k=0; k<memoryWords/length; k++)
      {
        for (i=start; i<end; i = i + 512)
        {
          result[thread] = result[thread]
            & xird[xird[i+   0]] | xird[xird[i+   2]]
            & xird[xird[i+   4]] | xird[xird[i+   6]]
            & xird[xird[i+   8]] | xird[xird[i+  10]]
            & xird[xird[i+  12]] | xird[xird[i+  14]]
            & xird[xird[i+  16]] | xird[xird[i+  18]]
            & xird[xird[i+  20]] | xird[xird[i+  22]]
            & xird[xird[i+  24]] | xird[xird[i+  26]]
            & xird[xird[i+  28]] | xird[xird[i+  30]]
            & xird[xird[i+  32]] | xird[xird[i+  34]]
            & xird[xird[i+  36]] | xird[xird[i+  38]]
            & xird[xird[i+  40]] | xird[xird[i+  42]]
            & xird[xird[i+  44]] | xird[xird[i+  46]]
            & xird[xird[i+  48]] | xird[xird[i+  50]]
            & xird[xird[i+  52]] | xird[xird[i+  54]]
            & xird[xird[i+  56]] | xird[xird[i+  58]]
            & xird[xird[i+  60]] | xird[xird[i+  62]]
            & xird[xird[i+  64]] | xird[xird[i+  66]]
            & xird[xird[i+  68]] | xird[xird[i+  70]]
            & xird[xird[i+  72]] | xird[xird[i+  74]]
            & xird[xird[i+  76]] | xird[xird[i+  78]]
            & xird[xird[i+  80]] | xird[xird[i+  82]]
            & xird[xird[i+  84]] | xird[xird[i+  86]]
            & xird[xird[i+  88]] | xird[xird[i+  90]]
            & xird[xird[i+  92]] | xird[xird[i+  94]]
            & xird[xird[i+  96]] | xird[xird[i+  98]]
            & xird[xird[i+ 100]] | xird[xird[i+ 102]]
            & xird[xird[i+ 104]] | xird[xird[i+ 106]]
            & xird[xird[i+ 108]] | xird[xird[i+ 110]]
            & xird[xird[i+ 112]] | xird[xird[i+ 114]]
            & xird[xird[i+ 116]] | xird[xird[i+ 118]]
            & xird[xird[i+ 120]] | xird[xird[i+ 122]]
            & xird[xird[i+ 124]] | xird[xird[i+ 126]]
            & xird[xird[i+ 128]] | xird[xird[i+ 130]]
            & xird[xird[i+ 132]] | xird[xird[i+ 134]]
            & xird[xird[i+ 136]] | xird[xird[i+ 138]]
            & xird[xird[i+ 140]] | xird[xird[i+ 142]]
            & xird[xird[i+ 144]] | xird[xird[i+ 146]]
            & xird[xird[i+ 148]] | xird[xird[i+ 150]]
            & xird[xird[i+ 152]] | xird[xird[i+ 154]]
            & xird[xird[i+ 156]] | xird[xird[i+ 158]]
            & xird[xird[i+ 160]] | xird[xird[i+ 162]]
            & xird[xird[i+ 164]] | xird[xird[i+ 166]]
            & xird[xird[i+ 168]] | xird[xird[i+ 170]]
            & xird[xird[i+ 172]] | xird[xird[i+ 174]]
            & xird[xird[i+ 176]] | xird[xird[i+ 178]]
            & xird[xird[i+ 180]] | xird[xird[i+ 182]]
            & xird[xird[i+ 184]] | xird[xird[i+ 186]]
            & xird[xird[i+ 188]] | xird[xird[i+ 190]]
            & xird[xird[i+ 192]] | xird[xird[i+ 194]]
            & xird[xird[i+ 196]] | xird[xird[i+ 198]]
            & xird[xird[i+ 200]] | xird[xird[i+ 202]]
            & xird[xird[i+ 204]] | xird[xird[i+ 206]]
            & xird[xird[i+ 208]] | xird[xird[i+ 210]]
            & xird[xird[i+ 212]] | xird[xird[i+ 214]]
            & xird[xird[i+ 216]] | xird[xird[i+ 218]]
            & xird[xird[i+ 220]] | xird[xird[i+ 222]]
            & xird[xird[i+ 224]] | xird[xird[i+ 226]]
            & xird[xird[i+ 228]] | xird[xird[i+ 230]]
            & xird[xird[i+ 232]] | xird[xird[i+ 234]]
            & xird[xird[i+ 236]] | xird[xird[i+ 238]]
            & xird[xird[i+ 240]] | xird[xird[i+ 242]]
            & xird[xird[i+ 244]] | xird[xird[i+ 246]]
            & xird[xird[i+ 248]] | xird[xird[i+ 250]]
            & xird[xird[i+ 252]] | xird[xird[i+ 254]]
            & xird[xird[i+ 256]] | xird[xird[i+ 258]]
            & xird[xird[i+ 260]] | xird[xird[i+ 262]]
            & xird[xird[i+ 264]] | xird[xird[i+ 266]]
            & xird[xird[i+ 268]] | xird[xird[i+ 270]]
            & xird[xird[i+ 272]] | xird[xird[i+ 274]]
            & xird[xird[i+ 276]] | xird[xird[i+ 278]]
            & xird[xird[i+ 280]] | xird[xird[i+ 282]]
            & xird[xird[i+ 284]] | xird[xird[i+ 286]]
            & xird[xird[i+ 288]] | xird[xird[i+ 290]]
            & xird[xird[i+ 292]] | xird[xird[i+ 294]]
            & xird[xird[i+ 296]] | xird[xird[i+ 298]]
            & xird[xird[i+ 300]] | xird[xird[i+ 302]]
            & xird[xird[i+ 304]] | xird[xird[i+ 306]]
            & xird[xird[i+ 308]] | xird[xird[i+ 310]]
            & xird[xird[i+ 312]] | xird[xird[i+ 314]]
            & xird[xird[i+ 316]] | xird[xird[i+ 318]]
            & xird[xird[i+ 320]] | xird[xird[i+ 322]]
            & xird[xird[i+ 324]] | xird[xird[i+ 326]]
            & xird[xird[i+ 328]] | xird[xird[i+ 330]]
            & xird[xird[i+ 332]] | xird[xird[i+ 334]]
            & xird[xird[i+ 336]] | xird[xird[i+ 338]]
            & xird[xird[i+ 340]] | xird[xird[i+ 342]]
            & xird[xird[i+ 344]] | xird[xird[i+ 346]]
            & xird[xird[i+ 348]] | xird[xird[i+ 350]]
            & xird[xird[i+ 352]] | xird[xird[i+ 354]]
            & xird[xird[i+ 356]] | xird[xird[i+ 358]]
            & xird[xird[i+ 360]] | xird[xird[i+ 362]]
            & xird[xird[i+ 364]] | xird[xird[i+ 366]]
            & xird[xird[i+ 368]] | xird[xird[i+ 370]]
            & xird[xird[i+ 372]] | xird[xird[i+ 374]]
            & xird[xird[i+ 376]] | xird[xird[i+ 378]]
            & xird[xird[i+ 380]] | xird[xird[i+ 382]]
            & xird[xird[i+ 384]] | xird[xird[i+ 386]]
            & xird[xird[i+ 388]] | xird[xird[i+ 390]]
            & xird[xird[i+ 392]] | xird[xird[i+ 394]]
            & xird[xird[i+ 396]] | xird[xird[i+ 398]]
            & xird[xird[i+ 400]] | xird[xird[i+ 402]]
            & xird[xird[i+ 404]] | xird[xird[i+ 406]]
            & xird[xird[i+ 408]] | xird[xird[i+ 410]]
            & xird[xird[i+ 412]] | xird[xird[i+ 414]]
            & xird[xird[i+ 416]] | xird[xird[i+ 418]]
            & xird[xird[i+ 420]] | xird[xird[i+ 422]]
            & xird[xird[i+ 424]] | xird[xird[i+ 426]]
            & xird[xird[i+ 428]] | xird[xird[i+ 430]]
            & xird[xird[i+ 432]] | xird[xird[i+ 434]]
            & xird[xird[i+ 436]] | xird[xird[i+ 438]]
            & xird[xird[i+ 440]] | xird[xird[i+ 442]]
            & xird[xird[i+ 444]] | xird[xird[i+ 446]]
            & xird[xird[i+ 448]] | xird[xird[i+ 450]]
            & xird[xird[i+ 452]] | xird[xird[i+ 454]]
            & xird[xird[i+ 456]] | xird[xird[i+ 458]]
            & xird[xird[i+ 460]] | xird[xird[i+ 462]]
            & xird[xird[i+ 464]] | xird[xird[i+ 466]]
            & xird[xird[i+ 468]] | xird[xird[i+ 470]]
            & xird[xird[i+ 472]] | xird[xird[i+ 474]]
            & xird[xird[i+ 476]] | xird[xird[i+ 478]]
            & xird[xird[i+ 480]] | xird[xird[i+ 482]]
            & xird[xird[i+ 484]] | xird[xird[i+ 486]]
            & xird[xird[i+ 488]] | xird[xird[i+ 490]]
            & xird[xird[i+ 492]] | xird[xird[i+ 494]]
            & xird[xird[i+ 496]] | xird[xird[i+ 498]]
            & xird[xird[i+ 500]] | xird[xird[i+ 502]]
            & xird[xird[i+ 504]] | xird[xird[i+ 506]]
            & xird[xird[i+ 508]] | xird[xird[i+ 510]];
        }
        end = end + length;
        if (end > memoryWords) end = length;
        start = end - length;
      }
  }
  return;
}

void thread1TestRW(int xiwr[], int thread)    
{
  int i, j, k;
  int strtWRW, lastWRW;
  int  start, end, length;

  length = (int)(memoryWords/threads);
  start  = thread * length;
  end    = start  + length;

  if (test > 4) pthread_mutex_lock( &mutex1 );

  for (j=0; j<extraLoops; j++)
  {
      for (k=0; k<memoryWords/length; k++)
      {
        for (i=start; i<end; i = i + 512)
        {
             xiwr[xiwr[i+   0]] = xiwr[xiwr[i+   2]];
             xiwr[xiwr[i+   4]] = xiwr[xiwr[i+   6]];
             xiwr[xiwr[i+   8]] = xiwr[xiwr[i+  10]];
             xiwr[xiwr[i+  12]] = xiwr[xiwr[i+  14]];
             xiwr[xiwr[i+  16]] = xiwr[xiwr[i+  18]];
             xiwr[xiwr[i+  20]] = xiwr[xiwr[i+  22]];
             xiwr[xiwr[i+  24]] = xiwr[xiwr[i+  26]];
             xiwr[xiwr[i+  28]] = xiwr[xiwr[i+  30]];
             xiwr[xiwr[i+  32]] = xiwr[xiwr[i+  34]];
             xiwr[xiwr[i+  36]] = xiwr[xiwr[i+  38]];
             xiwr[xiwr[i+  40]] = xiwr[xiwr[i+  42]];
             xiwr[xiwr[i+  44]] = xiwr[xiwr[i+  46]];
             xiwr[xiwr[i+  48]] = xiwr[xiwr[i+  50]];
             xiwr[xiwr[i+  52]] = xiwr[xiwr[i+  54]];
             xiwr[xiwr[i+  56]] = xiwr[xiwr[i+  58]];
             xiwr[xiwr[i+  60]] = xiwr[xiwr[i+  62]];
             xiwr[xiwr[i+  64]] = xiwr[xiwr[i+  66]];
             xiwr[xiwr[i+  68]] = xiwr[xiwr[i+  70]];
             xiwr[xiwr[i+  72]] = xiwr[xiwr[i+  74]];
             xiwr[xiwr[i+  76]] = xiwr[xiwr[i+  78]];
             xiwr[xiwr[i+  80]] = xiwr[xiwr[i+  82]];
             xiwr[xiwr[i+  84]] = xiwr[xiwr[i+  86]];
             xiwr[xiwr[i+  88]] = xiwr[xiwr[i+  90]];
             xiwr[xiwr[i+  92]] = xiwr[xiwr[i+  94]];
             xiwr[xiwr[i+  96]] = xiwr[xiwr[i+  98]];
             xiwr[xiwr[i+ 100]] = xiwr[xiwr[i+ 102]];
             xiwr[xiwr[i+ 104]] = xiwr[xiwr[i+ 106]];
             xiwr[xiwr[i+ 108]] = xiwr[xiwr[i+ 110]];
             xiwr[xiwr[i+ 112]] = xiwr[xiwr[i+ 114]];
             xiwr[xiwr[i+ 116]] = xiwr[xiwr[i+ 118]];
             xiwr[xiwr[i+ 120]] = xiwr[xiwr[i+ 122]];
             xiwr[xiwr[i+ 124]] = xiwr[xiwr[i+ 126]];
             xiwr[xiwr[i+ 128]] = xiwr[xiwr[i+ 130]];
             xiwr[xiwr[i+ 132]] = xiwr[xiwr[i+ 134]];
             xiwr[xiwr[i+ 136]] = xiwr[xiwr[i+ 138]];
             xiwr[xiwr[i+ 140]] = xiwr[xiwr[i+ 142]];
             xiwr[xiwr[i+ 144]] = xiwr[xiwr[i+ 146]];
             xiwr[xiwr[i+ 148]] = xiwr[xiwr[i+ 150]];
             xiwr[xiwr[i+ 152]] = xiwr[xiwr[i+ 154]];
             xiwr[xiwr[i+ 156]] = xiwr[xiwr[i+ 158]];
             xiwr[xiwr[i+ 160]] = xiwr[xiwr[i+ 162]];
             xiwr[xiwr[i+ 164]] = xiwr[xiwr[i+ 166]];
             xiwr[xiwr[i+ 168]] = xiwr[xiwr[i+ 170]];
             xiwr[xiwr[i+ 172]] = xiwr[xiwr[i+ 174]];
             xiwr[xiwr[i+ 176]] = xiwr[xiwr[i+ 178]];
             xiwr[xiwr[i+ 180]] = xiwr[xiwr[i+ 182]];
             xiwr[xiwr[i+ 184]] = xiwr[xiwr[i+ 186]];
             xiwr[xiwr[i+ 188]] = xiwr[xiwr[i+ 190]];
             xiwr[xiwr[i+ 192]] = xiwr[xiwr[i+ 194]];
             xiwr[xiwr[i+ 196]] = xiwr[xiwr[i+ 198]];
             xiwr[xiwr[i+ 200]] = xiwr[xiwr[i+ 202]];
             xiwr[xiwr[i+ 204]] = xiwr[xiwr[i+ 206]];
             xiwr[xiwr[i+ 208]] = xiwr[xiwr[i+ 210]];
             xiwr[xiwr[i+ 212]] = xiwr[xiwr[i+ 214]];
             xiwr[xiwr[i+ 216]] = xiwr[xiwr[i+ 218]];
             xiwr[xiwr[i+ 220]] = xiwr[xiwr[i+ 222]];
             xiwr[xiwr[i+ 224]] = xiwr[xiwr[i+ 226]];
             xiwr[xiwr[i+ 228]] = xiwr[xiwr[i+ 230]];
             xiwr[xiwr[i+ 232]] = xiwr[xiwr[i+ 234]];
             xiwr[xiwr[i+ 236]] = xiwr[xiwr[i+ 238]];
             xiwr[xiwr[i+ 240]] = xiwr[xiwr[i+ 242]];
             xiwr[xiwr[i+ 244]] = xiwr[xiwr[i+ 246]];
             xiwr[xiwr[i+ 248]] = xiwr[xiwr[i+ 250]];
             xiwr[xiwr[i+ 252]] = xiwr[xiwr[i+ 254]];
             xiwr[xiwr[i+ 256]] = xiwr[xiwr[i+ 258]];
             xiwr[xiwr[i+ 260]] = xiwr[xiwr[i+ 262]];
             xiwr[xiwr[i+ 264]] = xiwr[xiwr[i+ 266]];
             xiwr[xiwr[i+ 268]] = xiwr[xiwr[i+ 270]];
             xiwr[xiwr[i+ 272]] = xiwr[xiwr[i+ 274]];
             xiwr[xiwr[i+ 276]] = xiwr[xiwr[i+ 278]];
             xiwr[xiwr[i+ 280]] = xiwr[xiwr[i+ 282]];
             xiwr[xiwr[i+ 284]] = xiwr[xiwr[i+ 286]];
             xiwr[xiwr[i+ 288]] = xiwr[xiwr[i+ 290]];
             xiwr[xiwr[i+ 292]] = xiwr[xiwr[i+ 294]];
             xiwr[xiwr[i+ 296]] = xiwr[xiwr[i+ 298]];
             xiwr[xiwr[i+ 300]] = xiwr[xiwr[i+ 302]];
             xiwr[xiwr[i+ 304]] = xiwr[xiwr[i+ 306]];
             xiwr[xiwr[i+ 308]] = xiwr[xiwr[i+ 310]];
             xiwr[xiwr[i+ 312]] = xiwr[xiwr[i+ 314]];
             xiwr[xiwr[i+ 316]] = xiwr[xiwr[i+ 318]];
             xiwr[xiwr[i+ 320]] = xiwr[xiwr[i+ 322]];
             xiwr[xiwr[i+ 324]] = xiwr[xiwr[i+ 326]];
             xiwr[xiwr[i+ 328]] = xiwr[xiwr[i+ 330]];
             xiwr[xiwr[i+ 332]] = xiwr[xiwr[i+ 334]];
             xiwr[xiwr[i+ 336]] = xiwr[xiwr[i+ 338]];
             xiwr[xiwr[i+ 340]] = xiwr[xiwr[i+ 342]];
             xiwr[xiwr[i+ 344]] = xiwr[xiwr[i+ 346]];
             xiwr[xiwr[i+ 348]] = xiwr[xiwr[i+ 350]];
             xiwr[xiwr[i+ 352]] = xiwr[xiwr[i+ 354]];
             xiwr[xiwr[i+ 356]] = xiwr[xiwr[i+ 358]];
             xiwr[xiwr[i+ 360]] = xiwr[xiwr[i+ 362]];
             xiwr[xiwr[i+ 364]] = xiwr[xiwr[i+ 366]];
             xiwr[xiwr[i+ 368]] = xiwr[xiwr[i+ 370]];
             xiwr[xiwr[i+ 372]] = xiwr[xiwr[i+ 374]];
             xiwr[xiwr[i+ 376]] = xiwr[xiwr[i+ 378]];
             xiwr[xiwr[i+ 380]] = xiwr[xiwr[i+ 382]];
             xiwr[xiwr[i+ 384]] = xiwr[xiwr[i+ 386]];
             xiwr[xiwr[i+ 388]] = xiwr[xiwr[i+ 390]];
             xiwr[xiwr[i+ 392]] = xiwr[xiwr[i+ 394]];
             xiwr[xiwr[i+ 396]] = xiwr[xiwr[i+ 398]];
             xiwr[xiwr[i+ 400]] = xiwr[xiwr[i+ 402]];
             xiwr[xiwr[i+ 404]] = xiwr[xiwr[i+ 406]];
             xiwr[xiwr[i+ 408]] = xiwr[xiwr[i+ 410]];
             xiwr[xiwr[i+ 412]] = xiwr[xiwr[i+ 414]];
             xiwr[xiwr[i+ 416]] = xiwr[xiwr[i+ 418]];
             xiwr[xiwr[i+ 420]] = xiwr[xiwr[i+ 422]];
             xiwr[xiwr[i+ 424]] = xiwr[xiwr[i+ 426]];
             xiwr[xiwr[i+ 428]] = xiwr[xiwr[i+ 430]];
             xiwr[xiwr[i+ 432]] = xiwr[xiwr[i+ 434]];
             xiwr[xiwr[i+ 436]] = xiwr[xiwr[i+ 438]];
             xiwr[xiwr[i+ 440]] = xiwr[xiwr[i+ 442]];
             xiwr[xiwr[i+ 444]] = xiwr[xiwr[i+ 446]];
             xiwr[xiwr[i+ 448]] = xiwr[xiwr[i+ 450]];
             xiwr[xiwr[i+ 452]] = xiwr[xiwr[i+ 454]];
             xiwr[xiwr[i+ 456]] = xiwr[xiwr[i+ 458]];
             xiwr[xiwr[i+ 460]] = xiwr[xiwr[i+ 462]];
             xiwr[xiwr[i+ 464]] = xiwr[xiwr[i+ 466]];
             xiwr[xiwr[i+ 468]] = xiwr[xiwr[i+ 470]];
             xiwr[xiwr[i+ 472]] = xiwr[xiwr[i+ 474]];
             xiwr[xiwr[i+ 476]] = xiwr[xiwr[i+ 478]];
             xiwr[xiwr[i+ 480]] = xiwr[xiwr[i+ 482]];
             xiwr[xiwr[i+ 484]] = xiwr[xiwr[i+ 486]];
             xiwr[xiwr[i+ 488]] = xiwr[xiwr[i+ 490]];
             xiwr[xiwr[i+ 492]] = xiwr[xiwr[i+ 494]];
             xiwr[xiwr[i+ 496]] = xiwr[xiwr[i+ 498]];
             xiwr[xiwr[i+ 500]] = xiwr[xiwr[i+ 502]];
             xiwr[xiwr[i+ 504]] = xiwr[xiwr[i+ 506]];
             xiwr[xiwr[i+ 508]] = xiwr[xiwr[i+ 510]];
        }
        end = end + length;
        if (end > memoryWords) end = length;
        start = end - length;
      }
  }
  if (test > 4) pthread_mutex_unlock( &mutex1 );
  return;
}


